//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <mmsystem.h>
#include <stdio.h>
#include "Prefs.h"
#include "About.h"

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPreferencesO *PreferencesO;
//---------------------------------------------------------------------------
__fastcall TPreferencesO::TPreferencesO(TComponent* Owner) : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TPreferencesO::QuitButClick(TObject *Sender)
{
	Application -> Terminate();
}

//---------------------------------------------------------------------------

void TPreferencesO::LoadPrefsInfo (void)
{
    const int     BuffSize = 128;
    char          profileBuff[BuffSize];
    HKEY          hWindowInfo = NULL;
    unsigned long type        = REG_SZ;
    unsigned long fucked      = BuffSize;
    LONG          result      = RegOpenKey (HKEY_CURRENT_USER,
                                            (LPCTSTR)"software\\De Toni Ware",
                                            &hWindowInfo);

    if (result != 0)
        strcpy (profileBuff, DefaultProfile);
	else
    {
	    result = RegQueryValueEx(hWindowInfo, (LPTSTR)"Pyro Info", NULL, &type,
                                 (LPBYTE)profileBuff, &fucked);

        // Unable to obtain pyro profile, then use defaults.
        if (result != 0)
        	strcpy (profileBuff, DefaultProfile);
	}

    // Get info window form
    sscanf (profileBuff, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
    &prefs.explodeSnd,
    &prefs.pixelSize,
    &prefs.srNum,  &prefs.srExdNum,  &prefs.srTrailLen, &prefs.srCyc,
    &prefs.ssrNum, &prefs.ssrPodNum, &prefs.ssrExdNum,  &prefs.ssrTrailLen, &prefs.ssrCyc,
    &prefs.pNum,   &prefs.pExdNum,   &prefs.pTrailLen,  &prefs.pCyc,        &prefs.xRes,
    &prefs.yRes,   &prefs.bitDepth);

    RegCloseKey(hWindowInfo);

    ExplodSndChk->State       = (TCheckBoxState)prefs.explodeSnd;
    PixelSizeUD->Position     = (short)prefs.pixelSize;

    // Sky rocket
 	RockNumUD->Position       = (short)prefs.srNum;
    RockExNumUD->Position     = (short)prefs.srExdNum;
    RockTrailLenUD->Position  = (short)prefs.srTrailLen;
    RockCycsUD->Position      = (short)prefs.srCyc;

    // Super sky rocket
    SRockNumUD->Position      = (short)prefs.ssrNum;
    SRockPodNumUD->Position   = (short)prefs.ssrPodNum;
    SRockExNumUD->Position    = (short)prefs.ssrExdNum;
    SRockTrailLenUD->Position = (short)prefs.ssrTrailLen;
    SRockCycsUD->Position     = (short)prefs.ssrCyc;

    // Flower pot
    PotNumUD->Position        = (short)prefs.pNum;
    PotFlareNumUD->Position   = (short)prefs.pExdNum;
    PotTrailLenUD->Position   = (short)prefs.pTrailLen;
    PotCycsUD->Position       = (short)prefs.pCyc;

	XResUD->Position		  = (short)prefs.xRes;
    YResUD->Position		  = (short)prefs.yRes;

    switch (prefs.bitDepth)
    {
    	case 24:
        	Rad24bit -> Checked = true;
            break;

        case 16:
        	Rad16bit -> Checked = true;
        	break;

        default:
        	Rad8bit -> Checked  = true;
    }
}

void TPreferencesO::SavePrefsInfo (void)
{
    const int       BuffSize = 128;
    char            profileBuff[BuffSize];
    HKEY            hWindowInfo = NULL;
    LONG            result      = RegCreateKey (HKEY_CURRENT_USER, (LPCTSTR)"software\\De Toni Ware", &hWindowInfo);

    if (result != 0)
    {
        MessageBox (NULL, "Unable to open/create registry key!" , "Registry Error", MB_ICONSTOP | MB_OK);
        return;
    }

    prefs.explodeSnd  = ExplodSndChk->State;
    prefs.pixelSize   = PixelSizeUD->Position;

    // Sky rocket
 	prefs.srNum       = RockNumUD->Position;
    prefs.srExdNum    = RockExNumUD->Position;
    prefs.srTrailLen  = RockTrailLenUD->Position;
    prefs.srCyc       = RockCycsUD->Position;

    // Super sky rocket
    prefs.ssrNum      = SRockNumUD->Position;
    prefs.ssrPodNum   = SRockPodNumUD->Position;
    prefs.ssrExdNum   = SRockExNumUD->Position;
    prefs.ssrTrailLen = SRockTrailLenUD->Position;
    prefs.ssrCyc      = SRockCycsUD->Position;

    // Flower pot
    prefs.pNum        = PotNumUD->Position;
    prefs.pExdNum     = PotFlareNumUD->Position;
    prefs.pTrailLen   = PotTrailLenUD->Position;
    prefs.pCyc        = PotCycsUD->Position;

    // Screen information
    prefs.xRes        = XResUD->Position;
    prefs.yRes        = YResUD->Position;

    if (Rad24bit -> Checked != false)
    	prefs.bitDepth = 24;
	else if (Rad16bit -> Checked != false)
    	prefs.bitDepth = 16;
    else
    	prefs.bitDepth = 8;


    sprintf (profileBuff, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
    prefs.explodeSnd,
    prefs.pixelSize,
    prefs.srNum,  prefs.srExdNum,  prefs.srTrailLen, prefs.srCyc,
    prefs.ssrNum, prefs.ssrPodNum, prefs.ssrExdNum,  prefs.ssrTrailLen, prefs.ssrCyc,
    prefs.pNum,   prefs.pExdNum,   prefs.pTrailLen,  prefs.pCyc,        prefs.xRes,
    prefs.yRes,   prefs.bitDepth);

    RegSetValueEx (hWindowInfo, (LPCTSTR)"Pyro Info", NULL, REG_SZ, (CONST BYTE*)profileBuff, (DWORD) strlen (profileBuff));
    RegCloseKey   (hWindowInfo);
}

void __fastcall TPreferencesO::SaveButClick(TObject *Sender)
{
	SavePrefsInfo ();
    Application -> Terminate ();
}

//---------------------------------------------------------------------------
void __fastcall TPreferencesO::FormShow(TObject *Sender)
{
	LoadPrefsInfo ();
}
//---------------------------------------------------------------------------
