#ifndef FIX_MATH_HEADER
#define FIX_MATH_HEADER

// *** Sine, Co-Sine lookup table constants and variables ***
#define NUMOFDEGREES 256
#define SHIFT        18
#define ABS(X) (X<0?-X:X)
#define COS(X) cos_table[ABS(X)&NUMOFDEGREES-1]
#define SIN(X) sin_table[ABS(X)&NUMOFDEGREES-1]

extern long cos_table[NUMOFDEGREES];
extern long sin_table[NUMOFDEGREES];

// *** Random value lookup table ***
#define RNDTABSIZE   0xffff
#define randomTab(X) (rand_table [++rand_idx] % X)
extern unsigned short rand_idx;
extern unsigned short rand_table[RNDTABSIZE];

void BuildTables (void);
void DumpTables (void);

#endif // FIX_MATH_HEADER
