// **** Build new fix routines dynamically ****
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "fixed_math.h"

// *** Define trig lookup tables ***
long cos_table [NUMOFDEGREES];
long sin_table [NUMOFDEGREES];

// *** Define random variable lookup table ***
unsigned short rand_idx = 0;
unsigned short rand_table[RNDTABSIZE];

void BuildTables (void)
{
	double rad2deg  = 180.0 / 3.141592653589793;
	double incAmt   = 360.0 / NUMOFDEGREES;
	double curAngle = 0.0;

	// *** Build trig tables ***

	for (int degNum = 0; degNum < NUMOFDEGREES; degNum++)
	{
		cos_table[degNum] = (long) (cos (curAngle / rad2deg) * (1 << SHIFT));
		sin_table[degNum] = (long) (sin (curAngle / rad2deg) * (1 << SHIFT));
		curAngle = curAngle + incAmt;
	}
	
	/* Pick a seed. */
	srand(clock());

	for (int rnd = 0; rnd < RNDTABSIZE; rnd++)
	{
		// make random number suitable between range 0 - 0xffff
		rand_table[rnd] = (unsigned short) rand();
	}
}

/*
void DumpTables (void)
{
	printf ("\nSine table = ");
	for (int cnt = 0; cnt < NUMOFDEGREES; cnt++)
	{
		printf ("[%d] ", sin_table[cnt]);
	}

	printf ("\nCo-Sine table = ");
	for (cnt = 0; cnt < NUMOFDEGREES; cnt++)
	{
		printf ("[%d] ", cos_table[cnt]);
	}

	printf ("\nRandom number table = ");
	for (int rnd = 0; rnd < RNDTABSIZE; rnd++)
	{
		// make random number suitable between range 0 - 0xffff
		printf ("[%d] ", rand_table[rnd]);
	}

	printf ("\n");
}


void main (void)
{
	BuildTables();
	DumpTables();

	printf ("\n\n");
	for (int t = 0; t < 1000; t++)
	{
		printf (" %d ", randomFix (100));
	}
	printf ("\n");
}
*/







